Subject: Re: [RFC PATCH 1/6] hv_sock: Check hv_pkt_iter_first_raw()'s return value

From: Andrea Parri <[email-masked]>
Date: Fri, 15 Apr 2022 08:41:33 +0200

On Fri, Apr 15, 2022 at 03:33:23AM +0000, Michael Kelley (LINUX) wrote:
> From: Andrea Parri (Microsoft) <[email-masked]> Sent: Wednesday, April 13, 2022 1:48 PM
> > 
> > The function returns NULL if the ring buffer has no enough space
> > available for a packet descriptor.  The ring buffer's write_index
> 
> The first sentence wording is a bit scrambled.  I think you mean the
> ring buffer doesn't contain enough readable bytes to constitute a
> packet descriptor.

Indeed, replaced with your working.

> > is in memory which is shared with the Hyper-V host, its value is
> > thus subject to being changed at any time.
> 
> This second sentence is true, but I'm not making the connection
> with the code change below.   Evidently, there is some previous
> check made to ensure that enough bytes are available to be
> received when hvs_stream_dequeue() is called, so we assumed that
> NULL could never be returned?  I looked but didn't find such a check, 
> so maybe I didn't look carefully enough.  But now we are assuming
> that Hyper-V might have invalidated that previous check by 
> subsequently changing the write_index in a bogus way?  So now, NULL
> could be returned when previously we assumed it couldn't.

I think you're looking for hvs_stream_has_data().  (Previous checks
apart, hvs_stream_dequeue() will "dereference" the pointer so...)

Thanks,
  Andrea